window.onload = function () {

    //CodeMirror 設定
    //CodeMirror settings
    var editor = CodeMirror.fromTextArea(document.getElementById("content"), {
        mode: "htmlmixed",
        lineNumbers: true,
        lineWrapping: true,
        keyMap: "sublime",
        autoCloseBrackets: true,
        matchBrackets: true,
        showCursorWhenSelecting: true,
        theme: "vscode-dark",
        indentUnit: 4,
        indentWithTabs: true,
    });
    editor.save();
    editor.setSize("100%", 500);
    emmetCodeMirror(editor);

    //クイックタグ
    //Used QTags
    if (window.QTags && QTags.TagButton) {
        QTags.TagButton.prototype.callback = function (element, canvas, ed) {
            var cursor, html,
                text = editor.doc.getSelection(),
                start_tag = text.indexOf(this.tagStart),
                end_tag = text.indexOf(this.tagEnd);

            if (start_tag !== -1 && end_tag !== -1) {
                html = text.substring(this.tagStart.length, end_tag);
            } else {
                html = this.tagStart + text + this.tagEnd;
            }
            editor.doc.replaceSelection(html);
            if (text) {
                cursor = editor.doc.getCursor('end');
            } else {
                cursor = editor.doc.getCursor('start');
                cursor.ch += this.tagStart.length;
            }
            editor.doc.setCursor(cursor, cursor);
            editor.focus();
        };
    }

    // リンクタグ
    // used link tag
    if (window.wpLink) {
        wpLink.htmlUpdate = function() {
        var cursor,
            data = this.getAttrs(),
            tagStart = '<a',
            tagEnd = '</a>';
        $.each(data, function(name, value) {
            if (value) {
            tagStart += ' ' + name + '="' + value + '"';
            }
        });
        tagStart += '>';
        editor.replaceSelection(tagStart + editor.getSelection() + tagEnd);
        cursor = editor.doc.getCursor('start');
        editor.doc.setCursor(cursor.line, cursor.ch + tagStart.length);
        editor.focus();
        this.close();
        };
    }

    // メディアボタン
    // used media button
    if (wp.media && wp.media.editor) {
        wp.media.editor.insert_without_wp_emmet = wp.media.editor.insert;
        wp.media.editor.insert = function(h) {
            var cursor, txt_editor,
            txt_editor = window.tinymce && tinymce.get(wpActiveEditor);
            if (txt_editor && !txt_editor.hidden) {
                return this.insert_without_wp_emmet(h);
            }
            editor.doc.replaceSelection(h);
            cursor = editor.doc.getCursor();
            editor.doc.setCursor(cursor.line, cursor.ch + h.indexOf('>'));
            editor.focus();
        };
    }
};
